#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <stdarg.h>
#include <stdio.h>
#include <conio.h>
#include <alloc.h>
#include <dos.h>
#include "kbio.h"

/****************************** Wait_kbd *****************************/
void Wait_kbd() {
while (!kbhit());
delay(250);
/* Get_ext_kbd(&ch, &ch_high, &ch_ext ); */
}



/****************************** col **********************************/
void Col(int front, int back)
{
textcolor(front);
textbackground(back);
}



/****************************** Mst **********************************/
void Mst(int field_len, char ch, char *input)
{
int i, ai;
ai= field_len - strlen(input);
cprintf("%s", input);
textcolor(norm_text_col);
for(i=0; i<ai; i++) cprintf("%c", ch);
}



/****************************** Pst **********************************/
void Pst(int x, int y,char *text, int field_len, char ch, char *input)
{
static struct text_info ti;

gettextinfo(&ti);
gotoxy(x,y);
cprintf("%s", text); textcolor(norm_var_col);
Mst(field_len, ch, input);
textattr(ti.attribute);
}

/************************** Show_txt *********************************/
void Show_txt(int x, int y, char *error_text)
{
int strpit;
static struct text_info ti;

gettextinfo(&ti);
Col(moka_front_col, moka_bkg_col);

strpit=strlen(error_text);
gotoxy(x,y);
cprintf("%s", error_text);
Wait_kbd();
gotoxy(x,y);
Mst(strpit, ' ', "");
delay(500);
textattr(ti.attribute);
}


/************************** Show_var_txt *****************************/
void Show_var_txt(int x, int y, char *fmt, ...)  {
int strpit;
static struct text_info ti;
va_list ap;
char error_txt[120];

gettextinfo(&ti);
Col(moka_front_col, moka_bkg_col);

va_start(ap, fmt);
vsprintf(error_txt, fmt, ap);

strpit=strlen(error_txt);
gotoxy(x,y);
cprintf("%s", error_txt);
Wait_kbd();
gotoxy(x,y);
Mst(strpit, ' ', "");
delay(500);
textattr(ti.attribute);
va_end(ap);
}



/****************************** Y_n_dialog ***************************/
char Y_n_dialog(char *msg) {
char answer, txt[100];

strncpy(txt, msg, 90);
strcat(txt, " Y/N ?");
answer=' ';
while ((answer!=Yes) && (answer!=No)) {
	Show_txt(1,2,txt);
	answer=toupper(getch());
	}
return answer;
}



/************************** Terminate ********************************/
void Terminate(int x, int y, char *error_text)
{
Col(RED, BLACK);
//gotoxy(x,y);
cprintf("%s\r\n", error_text);
//gotoxy(x,y+1);
cprintf("Program terminating abnormally, press a key   " );
Wait_kbd();
exit(2);
}


/************************** Rap **************************************/
void Rap() {
printf("CORELEFT  %ld  %ld  ", coreleft(), farcoreleft());
}

